HelpScribble project file.
10
a. X. Oblq-0O6654
0
1



sheepdogsoftware.co.uk
TRUE


1
BrowseButtons()
0
FALSE

FALSE
7
10
Scribble10
Contents




Writing



FALSE
13
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}{\f4\fswiss\fprq2 System;}}
{\colortbl\red0\green0\blue0;\red128\green0\blue0;\red0\green0\blue255;\red0\green128\blue0;}
\deflang1033\pard\plain\f3\fs32\cf2\b Contents\plain\f3\fs20 
\par 
\par \plain\f3\fs20\cf3\strike WARNING\plain\f3\fs20\cf1 \{linkID=20\}\plain\f3\fs20 
\par 
\par \plain\f3\fs20\cf3\strike Introduction\plain\f3\fs20\cf1 \{linkID=25\}\plain\f3\fs20 
\par \plain\f3\fs20\cf3\strike The hardware\plain\f3\fs20\cf1 \{linkID=30\}\plain\f3\fs20 
\par \plain\f3\fs20\cf3\strike The software\plain\f3\fs20\cf1 \{linkID=40\}
\par \plain\f3\fs20\cf3\strike What's missing\plain\f3\fs20\cf1 \{linkID=45\}\plain\f3\fs20 
\par \plain\f3\fs20\cf3\strike Contacting author\plain\f3\fs20\cf1 \{linkID=50\}\plain\f3\fs20 
\par 
\par }
20
Scribble20
Warning




Writing



FALSE
34
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}{\f4\fswiss\fprq2 System;}}
{\colortbl\red0\green0\blue0;\red128\green0\blue0;\red0\green0\blue255;\red0\green128\blue0;}
\deflang1033\pard\plain\f3\fs32\cf2\b Warning\plain\f3\fs20 
\par 
\par There are three unrealted things on this page you need to know.
\par 
\par \plain\f3\fs24\cf1\b First warning:\plain\f3\fs24\cf1  \plain\f3\fs20 I think you can damage your DS2408 chip by the following condition:
\par 
\par DO NOT: set a pin as an output, in the low state, at the same time as external connections/ circuits connect 5 volts to that pin.
\par 
\par Another way of saying "set a pin as an output, in the low state" is "turn on the pull down transistor".
\par 
\par I THINK a pin connected to 5v or 0v AS LONG AS IT HAS been specified as a high output, by the presence of a 1 in the relevant position in the PIO Latch State Register (adress $89, written there by a Channal-Access Write command).
\par 
\par I THINK that if the RSTZ pin is tied to Vcc with a 10k resistor, and nothing is done in software to make that pin do something other than it's defualt, I THNIK in the conditions described, all of the pull down transistors will be off at power up.
\par 
\par If you do connect 5v directly to a pin which has it's pull down transistor turned on, if you don't damage the chip, the situation you've created will probably at least stop the Microlan from working...
\par 
\par \plain\f3\fs24\cf1\b Second warning:
\par \plain\f3\fs20 
\par Before the software will work, you need to change up to three things in the sourcecode and recompile it.
\par 
\par First, you need to put the id of your DS2408 into the program. The line where you do this is marked with "qhelptarget" (no "s) to help you find it easily, using Delphi's search.
\par 
\par Second and third: Depending on which COM port your adapter is on, and your adatper type, you may have to change two settings which are just after the chip ID setting.
\par 
\par \plain\f3\fs24\cf1\b Third warning:
\par \plain\f3\fs20 
\par For some reason, the program, at least in ther version of 12 April 2004, won't allow you to send messages to the 1-Wire rapidly. There's no harm in over-rapid requests... they just won't necessarily achieve what they should!
\par \plain\f3\fs20\cf3\strike 
\par 
\par Helpfile Table of Contents\plain\f3\fs20\cf1 \{linkID=10\}\plain\f3\fs20 
\par 
\par }
25
Scribble25
Introduction




Writing



FALSE
29
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}{\f4\fswiss\fprq2 System;}}
{\colortbl\red0\green0\blue0;\red0\green0\blue255;\red0\green128\blue0;\red128\green0\blue0;}
\deflang1033\pard\plain\f3\fs32\cf1\b Introduction\plain\f3\fs20 
\par 
\par Remember the land of the blind where the one-eyed man was king? Well, I claim to have at least one eye in the realms of 1-Wire.. but probably not two. You are welcome to the help you can derive from this and associated materials, but I don't promise they are perfect.
\par 
\par I have no association with Dallas or Maxim.
\par 
\par Anything you do, anything that happens as a result, YOU must take responsibility for. I accept no responsibility for anything arising from your use of these materials.... but I do wish you well in your endeavors!
\par 
\par ===============
\par 
\par The DS2408 is a member of the Dallas 1-Wire (aka MicroLan, both terms Dallas registered trademarks).
\par 
\par With it, you can connect up to 8 digital signals to your MicroLan. They can be inputs or outputs. Eight inputs can be driven with parasitic power. (See figure 21, pg 29 of the Dallas DS2408 datasheet, version of 22 Dec 2003. If you supply an external 5v, you can drive up to two LEDs directly with the chip. (There's a 20mA limit to the chip's power dissipation.) With 5v and some transistors or other drivers, you could drive 8 LEDs. Of course, if you can drive an LED, you can drive other things...
\par 
\par One limitation: The nature of the 1-wire means, I think, that there's significant latency: You won't be able to make the LEDs change state rapidly. I could be wrong about this.
\par 
\par The software this comes with will give you the basic routines to write to or read from the DS2408, written in Delphi. The essential routines have been made into discrete procedures for protability.
\par 
\par 
\par ================
\par 
\par Enjoy!
\par 
\par 
\par \plain\f3\fs20\cf2\strike Helpfile Table of Contents\plain\f3\fs20\cf3 \{linkID=10\}\plain\f3\fs20 
\par 
\par }
30
Scribble30
The hardware




Writing



FALSE
15
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}{\f4\fswiss\fprq2 System;}}
{\colortbl\red0\green0\blue0;\red0\green0\blue255;\red128\green0\blue0;\red0\green128\blue0;}
\deflang1033\pard\plain\f3\fs32\cf1\b The hardware\plain\f3\fs20 
\par 
\par In order to explore the chip, I made up a small circuit. (My ref PCB199).
\par 
\par It was based on the information in figure 22 of the Dallas DS2408 datasheet. I had RSTZ (pin ) pulled up to 5v with a 10k resistor. I had an LED connected through 470 ohms to 5v on pins 7 and 8. I had switches connected to pins 2 and 14. Also to pins 2 and 14 were 10k resistors which were connected to ground. The 1-Wire data/power line connected to the chip via pin 4. The chip's connection to ground was via pin 5. There was a 47uF capacitor between the 5v supply and the ground. That was all for my test circuit!
\par 
\par I did it in a way that means individual i/o lines can be used for input or output just by changing a jumper and a resistor, the pcb doesn't need changing. Get in touch if your interested in the design, and could produce it in bulk for other experimenters.
\par 
\par The Dallas datasheet shows you how to connect other devices. Nothing is out of the ordinary.
\par 
\par \plain\f3\fs20\cf3\strike Helpfile Table of Contents\plain\f3\fs20\cf2 \{linkID=10\}\plain\f3\fs20 
\par 
\par }
40
Scribble40
The software




Writing



FALSE
35
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}{\f4\fswiss\fprq2 System;}}
{\colortbl\red0\green0\blue0;\red0\green255\blue0;\red0\green0\blue255;\red128\green0\blue0;\red0\green128\blue0;}
\deflang1033\pard\plain\f3\fs32\cf2\b The software\plain\f3\fs20 
\par 
\par When you run DS030, you get a single window with the following \plain\f3\fs24\cf1\b buttons:\plain\f3\fs20 
\par 
\par \plain\f3\fs24\cf1\b Quit: \plain\f3\fs20 Make program shut down.
\par 
\par \plain\f3\fs24\cf1\b Read PIO Logic State:\plain\f3\fs20  When you click this, the state of the pins at that moment is read, and displayed using "virtual LEDs" on the screen. N.B.: An "on" \plain\f3\fs20\i virtual\plain\f3\fs20  LED on the screen means that the pin is near zero volts. The lines float high, so, with the simple test hardware described on \plain\f3\fs20\cf4\strike the hardware page\plain\f3\fs20\cf3 \{linkID=30\}\plain\f3\fs20 , you have to close the input switch to turn on the on-screen virtual LED.
\par 
\par \plain\f3\fs24\cf1\b Write to Inputs:\plain\f3\fs20  When you click this, the pin states you have selected (see following) are transfered from the program to the chip. More on this below.
\par 
\par \plain\f3\fs24\cf1\b Start/ Stop Loop:\plain\f3\fs20  When you click this, the program begins (or stops) a cycle of reading the pins, writing your output specs to the output pins. you can change the enablings (see below), the output state requirements, or the input states as you wish while the cycle runs. N.B.: The cycle is quite slow, and only a read or a write occurs each time the "Read" asnd "Write" buttons flash. (The program alternates reading and writing). Thus, there may be a delay (4 seconds- ish- max) between a change and a result.
\par 
\par ____________________
\par 
\par In the bottom of the window, there are two panels. The left hand panel has 8 check boxes. If you check one, it enables that bit of the chip for output, i.e. the pin's pull down transistor can be turned on.
\par 
\par The point of the "bit enable" mechanism is so that you can be protected from accidentally turning on the pull down transistor of a bit which is hardwired to 5v outside the DS2408... which is NOT a good thing to do! As long as the relevant "Click to enable..." checkbox is ticked, the pull down transistor will not be turned on, regardless of the state of the "Click to toggle..." checkbox.
\par 
\par In the upper part of the right hand panel, there are 8 check boxes. Check a box to make the coresponding pin high. Uncheck the box to turn on the pull down transistor inside the DS2408, thus creating a circuit to 0v. The "Write to outputs" routine is called each time you click one, so remember that the 1-Wire needs a little time to "gather it's thoughts", and don't click faster than about once per two seconds. N.B.: In the simple test circuit described \plain\f3\fs20\cf4\strike the hardware page\plain\f3\fs20\cf3 \{linkID=30\}\plain\f3\fs20  ,if a bit is ON, the real LED on the pcb is OFF. Sorry if you find that confusing. It won't be, as long as you remember that the LEDs have their fixed end connected to 5v so when theswitched end goes low, the LED goes on.
\par 
\par The lower part of the right hand panel has the\plain\f3\fs20\i  virtual\plain\f3\fs20  LEDs already described which tell you the state of the inputs, WHEN YOU CLICK the "Read PIO..." button, or if you have the program looping.
\par 
\par ____________________
\par 
\par In the middle of the screen there are two error reports. The "TKB Error returned" is an error code arising from my program. If it is zero, all is well. If it IS zero, the "Dallas Error" is meaningless.
\par 
\par The second error report, "Dallas Error returned", IF the TKB Error was NOT zero, is an error code which has come from the 1-Wire software, and is passed on for your consideration.
\par 
\par There is much more on the internals of the program in it's sourecode.
\par 
\par \plain\f3\fs20\cf4\strike Helpfile Table of Contents\plain\f3\fs20\cf3 \{linkID=10\}\plain\f3\fs20 
\par 
\par }
45
Scribble45
What's Missing




Writing



FALSE
14
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}{\f4\fswiss\fprq2 System;}}
{\colortbl\red0\green0\blue0;\red0\green0\blue255;\red128\green0\blue0;\red0\green128\blue0;}
\deflang1033\pard\plain\f3\fs32\cf1\b What's Missing\plain\f3\fs20 
\par 
\par There are two major omissions from this program, plus some minor ones. The DS2408 is a versatile chip, and the program does not exercise all of it's capabilities.
\par 
\par The major omission is software to demonstrate the chip's asynchronous input monitoring capabilities. Suppose in your application, the master computer monitoriing a number of chips on the 1-Wire LAN only "looks" at the DS2408 once a minute. Suppose at some point when the master computer was NOT looking, one of the inputs which is usually low went high, and then low again, while the master wasn't "looking". You can get the DS2408 to "remember" such things, and report them to the master when it suits the master to ask. If you want this before I get around to incorporating it, you need to look into the PIO Activity State Latch Register, page 9 of the datasheet.
\par 
\par I have also done nothing with the chip's capability for responding to conditional searches by the master computer. This is something present in most 1-Wire chips. It provides a way for chips to go into a state which makes them stand out when the master goes to the LAN and "says" "Are there any chips with messages for me?"
\par 
\par The minor(?) omissions are in respect of the various things you can do with the chip's pin 10, RSTZ. It can either be an input, to reset things, or an output used for things like "Data Ready".... It defaults to being an input, and you can just tie it high through a 10k resistor for a quiet life... devoid of certain features that harder working engineers get to play with!
\par 
\par \plain\f3\fs20\cf3\strike Helpfile Table of Contents\plain\f3\fs20\cf2 \{linkID=10\}\plain\f3\fs20 
\par }
50
Scribble50
Contacting the author




Writing



FALSE
20
{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fcharset1 Arial;}{\f3\fswiss\fcharset1 Arial;}}
{\colortbl\red0\green0\blue0;\red0\green0\blue255;\red0\green128\blue0;\red128\green0\blue0;}
\deflang1033\pard\plain\f3\fs32\cf1\b Contacting the author
\par 
\par \plain\f2\fs20 The author of this helpfile and the program it relates to (DS030), and the webpage where more information can be found...
\par 
\par http://ourworld.compuserve.com/homepages/TK_Boyd/Dst1main.htm
\par 
\par \plain\f3\fs20 ... is TK Boyd.
\par 
\par He can be contacted as described at....
\par 
\par http://sheepdogsoftware.co.uk/ctact.htm
\par 
\par Failing that, use Google to look for TK Boyd and Sheepdog Software. As the latter is a trademark, you shouldn't get too many false positives.
\par 
\par \plain\f3\fs20\cf2\strike Helpfile Table of Contents\plain\f3\fs20\cf3 \{linkID=10\}\plain\f3\fs20 
\par 
\par 
\par }
0
0
0
0
6
*InternetLink
-2147483640
Courier New
0
10
1
....
0
0
0
0
0
0
*ParagraphTitle
-2147483640
Arial
0
11
1
B...
0
0
0
0
0
0
*PopupLink
-2147483640
Arial
0
8
1
....
0
0
0
0
0
0
*PopupTopicTitle
16711680
Arial
0
10
1
B...
0
0
0
0
0
0
*TopicText
-2147483640
Arial
0
10
1
....
0
0
0
0
0
0
*TopicTitle
16711680
Arial
0
16
1
B...
0
0
0
0
0
0
